' FileName: FBD2FBD.Bas
' Date: 7/10/2014
' Author: Ben Ritchey
' Description: AUDIT DESCRIPT.ION FILE

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

FUNCTION PBMAIN () AS LONG

LOCAL A, E, FNAME, ONAME AS STRING
LOCAL B,C, TFLAG AS LONG
LOCAL Z AS STRING
LOCAL AA, AB AS LONG
LOCAL L AS LONG
LOCAL AC AS STRING
LOCAL PgmVer as String

' Code Starts Here * * * * * * * *
  ON ERROR GOTO INTERROR

' Do NOT change format of next line except x-x !!!
  PgmVer=" FBD2FBD v1.0.C "

200  COLOR 7
  PRINT " ";CHR$(232);PgmVer;"Auditing Descript.ion"

1000  COLOR 14

OPEN "DESCRIPT.ION" FOR INPUT AS #1
OPEN "DESCRIPT.NEW" FOR OUTPUT AS #2
ONAME$=""

NEXTION:

If not eof(1) then LINE INPUT#1,A else GOTO FINALIZE

rem A$=TRIM$(A$)
IF A="" THEN PRINT #2,A: GOTO NEXTION ' COPY BLANK LINE
'IF A="" THEN GOTO NEXTION ' Skip BLANK LINEs

C=ASC(MID$(A,1,1))
IF C<33 OR C>126 THEN PRINT #2,A: GOTO NEXTION  ' COPY INVALID ASCII OR SP

C=INSTR(A," ")
IF C=0 THEN FNAME$=A ELSE FNAME$=MID$(A,1,C-1)
IF FNAME=ONAME THEN PRINT FNAME$;" skipping dupe": GOTO NEXTION  ' SKIP DUPes

ONAME$=FNAME$: TFLAG=0

  FOR L=1 TO LEN(FNAME$)  ' LOWER CASE
    AA=ASC(MID$(FNAME$,L,1))
    IF AA>64 AND AA<91 THEN AA=AA+32: MID$(FNAME$,L,1)=CHR$(AA)
  NEXT L
  IF ISFILE(FNAME$) THEN TFLAG=1  ' FILE FOUND

  FOR L=1 TO LEN(FNAME$)  ' UPPER CASE
    AA=ASC(MID$(FNAME$,L,1))
    IF AA>96 AND AA<123 THEN AA=AA-32: MID$(FNAME$,L,1)=CHR$(AA)
  NEXT L
  IF ISFOLDER(FNAME$) THEN  TFLAG=2  ' FOLDER FOUND

If not isfile(FName+".diz") goto SaveFN  ' 

Open FName+".diz" for input as #3
Z=FName+space$(12-len(FName))+"  "

while not eof(3)
  if not eof(3) then line input#3,E$ else goto SetNewFN
  if mid$(E,1,1)=chr$(10) then E=mid$(E,2)
  if mid$(E,len(E),1)=chr$(10) then E=mid$(E,1,len(E)-1)
  if mid$(Z,len(Z),1)<>" " and mid$(E,1,1)<>" " then Z=Z+" "
  if E<>"" and E<>" " then Z=Z+E
wend  

SetNewFN:
close 3
A=Z
kill FName+".diz"

SaveFN:

IF TFLAG THEN
  PRINT #2,A  ' EXISTING FILE/FOLDER
 ELSE
  PRINT FName;" does NOT exist"
END IF
GOTO NEXTION

2000
FINALIZE:
2010
CLOSE
2015
 IF ISFILE("DESCRIPT.NEW") AND ISFILE("DESCRIPT.ION") THEN
   KILL "DESCRIPT.ION"
   NAME "DESCRIPT.NEW" AS "DESCRIPT.ION"
 end if
2040
' * * * * * * * *  C O D E  G O E S  H E R E  * * * * * * * *

REM  ERROR(123)
  GOTO FINISHED

PROMPT:
  COLOR 7: PRINT Z: COLOR 15: INPUT A$
  COLOR 3
 RETURN
MESSAGE:
  PRINT Z$
 RETURN

INTERROR:
  AB=ERL: AA=ERRCLEAR: AC=ERROR$(AA)

10000 PRINT

  BEEP
  COLOR 14
  PRINT "  Internal Error: ";
  COLOR 3: PRINT "Line";
  COLOR 15: PRINT AB;: COLOR 3: PRINT "  Code";
  COLOR 15: PRINT AA;: COLOR 3: PRINT " = ";
  COLOR 15: PRINT AC
  COLOR 3: PRINT "  Press any key ...";

  A="": WHILE A="": A=INKEY$: WEND
'  ON ERROR GOTO 0 ' Run-time use!
  RESUME FINISHED

' *** Debug
  BEEP
  PRINT "Ok": A="": WHILE A="": A=INKEY$: WEND
' *** Debug

FINISHED:
55000 COLOR 7
  ON ERROR GOTO EXITOR

55500  PRINT
'  CLOSE
'  SHELL "CLS"

EXITOR:

END FUNCTION

' End of PBD2PBD.Bas

