' FileName: IONFix.Bas
' Date: 1/9/2017
' Author: Ben Ritchey
' Description: Filter/fix Descript.ION file for invalid names

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

FUNCTION PBMAIN () AS LONG

Local B, A, PgmVer as String
Local C as Long

' Do NOT change format of next line except x-x !!!
  PgmVer=" IONFix v1.0.B "

Print: print " ";chr$(232);PgmVer;"{c} 2017 Ben Ritchey ";

Open "DESCRIPT.ION" for input as #1
Open "DESCRIPT.New" for output as #2

C=0
While not eof(1)
 Line input#1,A: B=trim$(ucase$(A))
 If B="DESCRIPT.ION" then incr C: goto Skipit
 If B="INDEX.HTML" then incr C: goto Skipit
 If B="INDEX.HTM" then incr C: goto Skipit
 If B="00_INDEX.HTM" then incr C: goto Skipit
 If B="FILES.FIX" then incr C: goto Skipit
 If B="TMP" then incr C: goto Skipit
 If B="OLD" then incr C: goto Skipit
 If B="BKP" then incr C: goto Skipit
 If B="NEW" then incr C: goto Skipit
 If B="UPLOAD" then incr C: goto Skipit
 If mid$(B,len(B)-2,3)=".ME" then incr C: goto Skipit
 If mid$(B,len(B)-3,4)=".LOG" then incr C: goto Skipit
 If mid$(B,len(B)-3,4)=".OLD" then incr C: goto Skipit
 If mid$(B,len(B)-3,4)=".DIZ" then incr C: goto Skipit
 Print #2,A
Skipit:
Wend
Close

If C>0 then print ", ";C;" records purged" else print
If isfile("DESCRIPT.NEW") then
  Kill "DESCRIPT.ION"
  Name "DESCRIPT.NEW" AS "DESCRIPT.ION"
end if

ENDITALL:
END FUNCTION

